;26012017 wbr reported: mistake if N=0
;03-05-2017      

Global Dim de.s(256)

#textfrom=256
#textto=257
#comboset=258
#btnadd=259
#checkU=260
#podst=300
#tbl=301

Enumeration
  #mnu_filesave
  #mnu_fileopen
  #mnu_filequit
  
  #mnu_podst
  #mnu_set_default
  #mnu_set_031
  #mnu_set_031_090d0a
  #mnu_set_bqwerty
  #mnu_set_lqwerty
  #mnu_split_text
  
  #mnu_caps_point
  #mnu_caps_my

  #mnu_paste
  #mnu_cut
  #mnu_copy
  #mnu_selall
  
  
EndEnumeration


;how:
;0 - reset
;1 - reset 0-31
;2 - reset 0-31  9,10, 13
Procedure resetval(how)
  
  i0=255
  If how=1 Or how=2
    i0=32
  EndIf
  
  For i=0 To i0;255
    j=i
    Select how
      Case 1:
        If j<32
          j=32
        EndIf
      Case 2:
        If j<32 And j<>9 And j<>10 And j<>13
          j=32
        EndIf
    EndSelect
    
    SetGadgetText(i, Chr(j))
    de(i)=Chr(j)
  Next i
  
  SetGadgetText(0, "{0}")
  de(0)="{0}"
EndProcedure

Procedure converttext()
  sf.s=GetGadgetText(#textfrom)
  ;   If GetGadgetState(#checkU)
  ;     sf=UCase(sf)
  ;   EndIf
  st.s=""
  For i=1 To Len(sf)
    c.a=Asc(Mid(sf,i,1))
    st=st+de(c)
    
  Next i
  
  N = GetGadgetState(#tbl)
  If N
    sf=st
            st.s=""
            i=1
              While i<Len(sf)
                st=st+Mid(sf,i,N)+#CRLF$
                i+N
              Wend
              
  EndIf  
  
;  scrollbar
   HoldLine = SendMessage_(GadgetID(#textto), #EM_GETFIRSTVISIBLELINE, 0, 0)
  SetGadgetText(#textto,st)
  lResult = SendMessage_(GadgetID(#textto), #EM_LINESCROLL, 0, HoldLine)
;   
EndProcedure

Procedure loadtext(Files$)
     If ReadFile(0,Files$)
      fis=FileSize(Files$)
      If fis>0
        *bf=AllocateMemory(fis+1)
        ReadData(0,*bf,fis)
        ;Debug fis
        sf.s=""
        For i=0 To fis-1
          c.a=PeekA(*bf+i)
          If c<>13 Or c<>10
            sf=sf+GetGadgetText(c)
          Else
            sf=sf+Chr(c)
          EndIf
          ;Debug i
        Next i
        SetGadgetText(#textfrom,sf)
        FreeMemory(*bf)
      EndIf
      CloseFile(0)
      
      converttext()
      
    Else
      MessageRequester("error","Error reading"+Chr($0a)+Files$,#PB_MessageRequester_Ok)
    EndIf
 
EndProcedure


OpenWindow(0, 0, 0, 1000, 640, "Text Decoder 1.3.2a", #PB_Window_SystemMenu|#PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
StringGadget(#textfrom, 0, 0, 500, 340,"", #ES_MULTILINE|#ES_AUTOVSCROLL|#WS_VSCROLL|#WS_HSCROLL|#ESB_DISABLE_LEFT|#ESB_DISABLE_RIGHT)
StringGadget(#textto, 500, 0, 500, 340,"", #ES_MULTILINE|#ES_AUTOVSCROLL|#WS_VSCROLL|#WS_HSCROLL|#ESB_DISABLE_LEFT|#ESB_DISABLE_RIGHT)
EnableWindowDrop(0,#PB_Drop_Files,#PB_Drag_Copy)

SetTimer_(WindowID(0),1,500,0)

;

     If LoadFont(1, "Courier", 8)
       SetGadgetFont(#textfrom, FontID(1))
       SetGadgetFont(#textto, FontID(1))
     EndIf
;  Editor_FontSize(#textfrom, 8)
;  Editor_Font(#textfrom, "Courier New")
;  Editor_Format(#textfrom, #CFM_ITALIC|#CFM_STRIKEOUT)
 ; Editor_FontSize(#textto, 18)    
    

  TrackBarGadget(#tbl,500,350,500,20,0,80)
                 
StringGadget(#podst,10,590,1000-50,20,"podst")
GadgetToolTip(#podst,"")
; GadgetToolTip(#textfrom,"Paste, type or drop text file here")
; GadgetToolTip(#textto,"Result")

If CreateMenu(0, WindowID(0))    ; menu creation starts....
  MenuTitle("")
  MenuItem(#mnu_filesave, " ...")
  MenuItem(#mnu_fileopen, " ...")
  MenuBar()
  MenuItem(#mnu_filequit, "")
  
  MenuTitle("")
  MenuItem(#mnu_cut, ""+Chr(9)+"Ctrl+X")
  MenuItem(#mnu_copy, ""+Chr(9)+"Ctrl+C")
  MenuBar()
  MenuItem(#mnu_paste, ""+Chr(9)+"Ctrl+V")
  MenuBar()
  MenuItem(#mnu_selall, " "+Chr(9)+"Ctrl+A")
  MenuBar()
  MenuTitle("")
  MenuItem(#mnu_set_default, " ")
  
  MenuBar()
  MenuItem(#mnu_podst, "")
  MenuBar()

  MenuItem(#mnu_set_031, "  0-31")
  MenuItem(#mnu_set_031_090d0a, "  0-31  09/10/13")
  MenuBar()
  MenuItem(#mnu_set_lqwerty, "qwerty/")
  MenuItem(#mnu_set_bqwerty, "QWERTY/")
  MenuBar()
  MenuItem(#mnu_split_text, "  N...")
  
  OpenSubMenu("CAPS LOCK")
        MenuItem(#mnu_caps_point, " (.)")
        MenuItem(#mnu_caps_my, " ")
      CloseSubMenu()

EndIf

AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_A, #mnu_selall)

gn.i=0
For j=0 To 7
  For i=0 To 31
    If gn<256
      StringGadget(gn, i*30+8, 380+j*24, 20, 20, "+"+Chr(gn));350
      GadgetToolTip(gn, Str(gn)+":"+Chr(gn))
    EndIf
    gn+1
  Next i
Next j

resetval(0)

If CountProgramParameters()
  ;Debug ProgramParameter(0)
  loadtext(ProgramParameter(0))
EndIf

If FileSize("scrolly.txt")>0
  loadtext("scrolly.txt")
EndIf

isq=0
Repeat
  event=WaitWindowEvent()
  If GetAsyncKeyState_(#VK_ESCAPE)=-32767
    isq=1
  EndIf
  
  If event=#PB_Event_WindowDrop
    Files$ = EventDropFiles()
    Files$ = StringField(Files$, 1, Chr(10))
    loadtext(Files$)
  EndIf
  
  If EventType()=#PB_EventType_Change
    eg=EventGadget()
    ;Debug eg
    If eg>0 And eg<256
      de(eg)=GetGadgetText(eg)
      converttext()
    EndIf
  EndIf
  
  ;how:
  ;0 - reset
  ;1 - reset 0-31
  ;2 - reset 0-31  9,10, 13
  Select event
    Case #WM_TIMER
          ;eg=#textto;EventGadget()
          ;ra.l=SendMessage_(GadgetID(eg), #EM_GETSEL, @Min,@Max)
          ;lpText.s=Mid(GetGadgetText(eg),Min+1,1)
      
      SendMessage_(GadgetID(#textfrom),#EM_GETSEL,@position,#Null)
      lpText.s=Mid(GetGadgetText(#textfrom),position+1,1)
          If lpText<>""
            For i=0 To 255
              SetGadgetColor(i,#PB_Gadget_FrontColor,-1)
              SetGadgetColor(i,#PB_Gadget_BackColor,-1)
            Next i
            SetGadgetColor( Asc( Mid(lpText,1,1) ), #PB_Gadget_BackColor, RGB(0,0,255))
            SetGadgetColor( Asc( Mid(lpText,1,1) ), #PB_Gadget_FrontColor, RGB(255,255,255))
          EndIf
    Case #PB_Event_Menu
      Select EventMenu()
        Case #mnu_filequit
          isq=1
          
        Case #mnu_podst
          po.s=GetGadgetText(#podst)
          For i=0 To Len(po)
            cha.s=Mid(po,i,1)
            SetGadgetText(i, cha)
            de(i)=Cha
          Next i
          converttext()

          
        Case #mnu_caps_my
             s.s=LCase( GetGadgetText(#textfrom) )
            ;sep.s=GetGadgetText(String_sep)
            r.s=""
            l=Len(s)
            If l>0
              needc=1
              For i=1 To l
                sc.s=Mid(s,i,1);single char
                If needc
                  sc=UCase(sc)
                  needc=0
                EndIf
                If sc=" "
                  needc=1
                  sc="";sep
                EndIf
                r=r+sc
              Next i
              SetGadgetText(#textto,r)
            EndIf

        Case #mnu_caps_point
          sf.s=LCase(GetGadgetText(#textfrom))
            r.s=""
            l=Len(sf)
            If l>0
              needc=1
              For i=1 To l
                sc.s=Mid(sf,i,1);single char
                If needc And sc<>" "
                  sc=UCase(sc)
                  needc=0
                EndIf
                If sc="." Or sc="!"; Or sc=" "
                  needc=1
                  ;sc=sep
                EndIf
                r=r+sc
              Next i
              SetGadgetText(#textto,r)
            EndIf
            
        Case #mnu_paste
          gad=GetActiveGadget()
          If gad>0
            SendMessage_(GadgetID(gad),#WM_PASTE,0,0)
          EndIf
          
        Case #mnu_cut
          gad=GetActiveGadget()
          If gad>0
            SendMessage_(GadgetID(gad),#WM_CUT,0,0)
          EndIf
        Case #mnu_copy
          gad=GetActiveGadget()
          If gad>0
            SendMessage_(GadgetID(gad),#WM_COPY,0,0)
          EndIf
        Case #mnu_selall
          gad=GetActiveGadget()
          If gad>0
            SendMessage_(GadgetID(gad),#EM_SETSEL,0,-1)
          EndIf
        Case #mnu_fileopen
          StandardFile$ = GetCurrentDirectory();"C:\autoexec.bat"   ; set initial file+path to display
                                               ; With next string we will set the search patterns ("|" as separator) for file displaying:
                                               ;  1st: "Text (*.txt)" as name, ".txt" and ".bat" as allowed extension
                                               ;  2nd: "PureBasic (*.pb)" as name, ".pb" as allowed extension
                                               ;  3rd: "All files (*.*) as name, "*.*" as allowed extension, valid for all files
          Pattern$ = "Charset (*.charset)|*.charset"
          Pattern = 0    ; use the first of the three possible patterns as standard
          File$ = SaveFileRequester(" ", StandardFile$, Pattern$, Pattern)
          If File$
            If ReadFile(0,File$)
              While Not Eof(0)
                p.s=ReadString(0)
                i=Val( Mid(p,1,3) )
                If i<256
                  de(i)=Trim( Mid(p,5) )
                  ;                   Debug de(i)+","+Str(i)
                  If i=$0A And de(i)="[10]"
                    de(i)=Chr($0A)
                  EndIf
                  
                  If i=$0D And de(i)="[13]"
                    de(i)=Chr($0D)
                  EndIf
                  
                  SetGadgetText(i,de(i))
                EndIf
              Wend
              CloseFile(0)
            Else
              MessageRequester("", " "+Chr($0A)+File$, 0)
            EndIf
            
          EndIf
        Case #mnu_filesave
          StandardFile$ = GetCurrentDirectory();"C:\autoexec.bat"   ; set initial file+path to display
                                               ; With next string we will set the search patterns ("|" as separator) for file displaying:
                                               ;  1st: "Text (*.txt)" as name, ".txt" and ".bat" as allowed extension
                                               ;  2nd: "PureBasic (*.pb)" as name, ".pb" as allowed extension
                                               ;  3rd: "All files (*.*) as name, "*.*" as allowed extension, valid for all files
          Pattern$ = "Charset (*.charset)|*.charset"
          Pattern = 0    ; use the first of the three possible patterns as standard
          File$ = SaveFileRequester("  ", StandardFile$, Pattern$, Pattern)
          If File$
            If LCase( Mid(File$,Len(File$)-7) )<>".charset"
              File$+".charset"
            EndIf
            
            If CreateFile(0,File$)
              For i=0 To 255
                p.s=de(i)
                If p=Chr($0A):p="[10]":EndIf
                If p=Chr($0D):p="[13]":EndIf
                WriteStringN (0,RSet(Str(i),3,"0")+"="+p )
              Next i
              CloseFile(0)
            Else
              MessageRequester("", "  "+Chr($0A)+File$, 0)
            EndIf
            
          EndIf
          
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;    
        Case #mnu_split_text
          sf.s=GetGadgetText(#textfrom)
          ;Result$ = InsertString(String$, StringToInsert$, Position)
          
          Input$ = InputRequester("  ", " ", "0032")
          
          ;            Debug Input$
          ;            Debug Str(Val(Input$))
          
          If Input$<>"";Str(Val(Input$))=Input$
            N.i=Val(Input$)
            st.s=""
            i=1
            If N>0
              While i<Len(sf)
                st=st+Mid(sf,i,N)+#CRLF$
                i+N
              Wend
              SetGadgetText(#textfrom,st)
              ;Debug st
              converttext()
            Else
              MessageRequester(" ", ":"+Chr($0A)+Input$, #PB_MessageRequester_Ok)
            EndIf
            
          Else
            MessageRequester(" ", ":"+Chr($0A)+Input$, #PB_MessageRequester_Ok)
          EndIf
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
          
        Case #mnu_set_default
          resetval(0)
          converttext()
        Case #mnu_set_031
          resetval(1)
          converttext()
        Case #mnu_set_031_090d0a
          resetval(2)
          converttext()
        Case #mnu_set_bqwerty,#mnu_set_lqwerty
          ;          Case #mnu_set_lqwerty
          Restore qwerty
          way=EventMenu()
          For i=0 To 255
            Read.a num.a
            Read.a c.a
            If way=#mnu_set_lqwerty
              num=Asc( LCase( Chr(num) ) )
              c=Asc( LCase( Chr(c) ) )
            EndIf
            de(num)=Chr(c)
            
            SetGadgetText( i,de(i) )
          Next i
          converttext()
      EndSelect
      
    Case #PB_Event_CloseWindow
      isq=1
    Case #PB_Event_Gadget
      Select EventGadget()
          ;;;;;;;;;;;;;;;;selection?;;;;;;;;;;;;;
;         Case #textfrom,#textto
;           eg=EventGadget()
;           ra.l=SendMessage_(GadgetID(eg), #EM_GETSEL, @Min,@Max)
; ;           min=ra>>16
; ;           max=ra&$FFFF
;           lpText.s=Mid(GetGadgetText(eg),Min+1,1)
;           If lpText<>""
;             For i=0 To 255
;               SetGadgetColor(i,#PB_Gadget_FrontColor,-1)
;               SetGadgetColor(i,#PB_Gadget_BackColor,-1)
;             Next i
;             SetGadgetColor( Asc( Mid(lpText,1,1) ), #PB_Gadget_BackColor, RGB(0,0,255))
;             SetGadgetColor( Asc( Mid(lpText,1,1) ), #PB_Gadget_FrontColor, RGB(255,255,255))
;           EndIf
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
        Case #tbl

          margin = GetGadgetState(#tbl)
          SetWindowTitle( 0,"Text Decoder 1.3, w:"+Str(margin) )
          converttext()

        Case 0 To 256
          converttext()
      EndSelect
  EndSelect
  
Until isq

KillTimer_(WindowID(0),1)

DataSection
  qwerty:
    IncludeFile "qwerty.pbi"
EndDataSection

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 132
; FirstLine = 45
; Folding = 5
; EnableXP
; UseIcon = txtdec.ico
; Executable = td132a.exe